Bug 56127 - [ILK] unigine-sanctuary performance reduced by 98%
Summary: [ILK] unigine-sanctuary performance reduced by 98%
Status: NEW
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965 (show other bugs)
Version: unspecified
Hardware: All Linux (All)
: lowest normal
Assignee: Intel 3D Bugs Mailing List
QA Contact: Intel 3D Bugs Mailing List
URL:
Whiteboard:
Keywords: bisected
: 57047 (view as bug list)
Depends on:
Blocks:
 
Reported: 2012-10-18 08:22 UTC by libo
Modified: 2018-01-10 19:28 UTC (History)
6 users (show)

See Also:
i915 platform:
i915 features:


Attachments
It's drirc for unigine game (1.29 KB, text/plain)
2013-03-11 00:17 UTC, meng
Details

Note You need to log in before you can comment on or make changes to this bug.
Description libo 2012-10-18 08:22:34 UTC
System Environment:       
----------------------------------------------
Hardware: SNB-Hunoriver 
 Libdrm:(master)libdrm-2.4.39-20-ga4cb7233a8da171e53b48b376be5c1265c29a612
 Mesa:	(master)53e36d333c9b619c1a5fe9a8d2d08665654b0234
Kernel: (drm-intel-nightly) 18986b8d32b30a9c986c042280aa9127b0f809e9

Bug detailed description:
----------------------------------------------
 unigine-sanctruary has 98% regression caused by Mesa. 
I have bisected it and found the following mesa commit is first bad commit:
commit 7139ab80ca9b1b3572ef6da98765ca783e8e5e3b
Author: Eric Anholt <eric@anholt.net>
Date:   Wed Aug 8 09:03:26 2012 -0700
    i965: Fix rendering to small mipmaps of depth/stencil buffers using a temp mt.
    Fixes 51 piglit tests (fbo-clear-formats, and most of the remaining failures
    in depthstencil).

Performance:
-------------------------
the performacne results of Nexuiz tested on SNB with 
(master)53e36d333 is 0.156 fps
with (master)4004620d is 8.69 fps.

 
Reproduce steps:
---------------------------------------------
1. xinit&
2.gnome-session
3.vblank_mode=0   ./bin/Sanctuary -video_app opengl -data_path ../ -sound_app null -system_script sanctuary/unigine.cpp -engine_config ../data/unigine.cfg -video_mode -1 -video_fullscreen 1 -extern_define PHORONIX -video_width 1600 -video_height 900
Comment 1 libo 2012-10-19 03:11:54 UTC
This bug also caused unigine-tropic reduce by 15%, which fps value changed from 8.51 to 7.17.
Comment 2 Gordon Jin 2012-11-13 07:46:36 UTC
*** Bug 57047 has been marked as a duplicate of this bug. ***
Comment 3 ye.tian 2012-11-13 08:08:36 UTC
The issue also exists on IronLake.
Comment 4 Eric Anholt 2012-12-23 00:19:26 UTC
I was never able to reproduce the original quoted 98% reduction in sanctuary performance, probably because of some configuration option that differs.  Please retest with master after the last round of validation fixes.
Comment 5 libo 2012-12-24 06:05:41 UTC
The issue still exists on my side both on SNB and ILK with latest Mesa code.
(In reply to comment #4)
> I was never able to reproduce the original quoted 98% reduction in sanctuary
> performance, probably because of some configuration option that differs. 
> Please retest with master after the last round of validation fixes.
Comment 6 Eric Anholt 2013-02-22 19:00:55 UTC
Reproduced it now -- the snb array miptrees are aligned to 11*j instead of 12*j like on ivb, so they consistently end up mis-aligned, and we get expensive workaround blits.

However, given that we're hitting this workaround, I suspect that you were seeing incorrect rendering in the before case.  I didn't quite get a test done for that, so can you confirm that you have watched the test and verified that it was rendering correctly before submitting this bug?
Comment 7 Gordon Jin 2013-03-10 04:12:48 UTC
Bo, please confirm if the previous commit (with good performance) works without rendering issue.
Comment 8 libo 2013-03-10 06:48:08 UTC
I tested it again and I can confirm that it's rendering correctly with both previous commit which perform well and the bad commit(53e36...) I mentioned in the report.  
On my side, "incorrect rendering" can only be reproduced when we do not copy "unigine_drirc" into /root/.drirc before run unigine-sanctruary.
  
(In reply to comment #6)
Comment 9 meng 2013-03-11 00:17:37 UTC
Created attachment 76300 [details]
It's drirc for unigine game
Comment 10 Eric Anholt 2013-03-11 19:45:29 UTC
For the record, you shouldn't be installing a static drirc into your homedir.  The drirc installed by Mesa (which doesn't match the one you posted) should be installed to /etc/ by your builds.
Comment 11 libo 2013-03-13 01:11:34 UTC
"incorrect rendering" still can't be reproduced with drirc that matches mesa.
Comment 12 libo 2013-04-15 08:02:09 UTC
can you reproduce this bug?
Comment 13 Gordon Jin 2013-05-27 00:20:05 UTC
(In reply to comment #6)
> Reproduced it now -- the snb array miptrees are aligned to 11*j instead of
> 12*j like on ivb, so they consistently end up mis-aligned, and we get
> expensive workaround blits.

Eric, do you have plan to fix this?
Comment 14 Eric Anholt 2013-06-08 01:08:14 UTC
We're hoping that Jordan's layered rendering work will end up fixing this.
Comment 15 Gordon Jin 2013-09-18 08:26:11 UTC
any update?
Comment 16 meng 2013-09-18 08:27:28 UTC
Meng is on Holidays due to 2013/9/22, please expect slow response.
Comment 17 ye.tian 2013-09-23 07:02:08 UTC
The problem is still exist on SNB.
good commit master branch : 5c8dd6cf7995   15.58  fps
bad commit  9.2    branch : 46273ba2564    2.98   fps
Comment 18 Gordon Jin 2013-12-13 00:51:31 UTC
Jordan, any plan?
Comment 19 meng 2014-05-26 12:59:47 UTC
The issue still exists on Mesa master branch.
Comment 20 Jordan Justen 2014-05-29 20:56:07 UTC
I posted an RFC patch series that seems to resolve this bug
 "Gen6 render surface state changes"
Comment 21 meng 2014-06-04 01:06:50 UTC
(In reply to comment #20)
> I posted an RFC patch series that seems to resolve this bug
>  "Gen6 render surface state changes"
Hi, is there a plan when putting the patch series into master?
Comment 22 meng 2014-06-16 07:43:39 UTC
The issue also exists on 2014Q2.
Comment 23 Jordan Justen 2014-06-16 07:58:44 UTC
(In reply to comment #21)
> (In reply to comment #20)
> > I posted an RFC patch series that seems to resolve this bug
> >  "Gen6 render surface state changes"
> Hi, is there a plan when putting the patch series into master?

I am working on an updated version of the patch series. I'll
try to post it this week to mesa-dev.

By the way, this patch series will not help ILK.
Comment 24 zhoujian 2014-06-27 08:44:39 UTC
This issue still exists on upstream.
Comment 25 zhoujian 2014-06-27 08:51:01 UTC
Actually,i want say this issue also still exists on mesa-10.2.2.
Comment 26 Jordan Justen 2014-08-21 03:28:17 UTC
For SNB, this should be resolved in master
a1dca7069bd46074f43658c87d396bff8cd4dffd.
Comment 27 meng 2014-08-21 05:49:09 UTC
(In reply to comment #26)
> For SNB, this should be resolved in master
> a1dca7069bd46074f43658c87d396bff8cd4dffd.
Verified it.
Comment 28 meng 2014-08-25 05:04:07 UTC
The issue is fixed on SNB, so change the title.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.